import java.util.Arrays;

public class MyUtilities {
	public static int[] reverseOf(int[] seq) {
		if(seq == null) {
			throw new IllegalArgumentException();
		}
		else {
			int[] output = new int[seq.length];
			
			for(int i = 0; i < seq.length; i ++) {
				output[seq.length - i - 1] = seq[i];
			}
			
			return output;
		}
	}
	
	public static boolean isFibSeq(int[] seq) {
		if(seq == null || seq.length < 2) {
			throw new IllegalArgumentException();
		}
		else { // reaching this point, we know seq has at least two elements
			boolean isFibSeq = seq[0] == 1 && seq[1] == 1;
			for(int i = 2; i < seq.length; i ++) {
				isFibSeq = seq[i] == seq[i - 1] + seq[i - 2];
			}
			return isFibSeq;
		}
	}
	
	public static int rps(char p1, char p2) {
		if(!(p1 == 'r' || p1 == 'p' || p1 == 's') || !(p2 == 'r' || p2 == 'p' || p2 == 's')) {
			throw new IllegalArgumentException();
		}
		else { // reaching this line means p1 is either r, p, or s. Same for p2.
			if(p1 == 'r') {
				if(p2 == 'r') {
					return 0;
				}
				else if(p2 == 'p') {
					return 2;
				}
				else { // p2 == 's'
					return 1;
				}
			}
			else if(p1 == 'p') {
				if(p2 == 'r') {
					return 1;
				}
				else if(p2 == 'p') {
					return 0;
				}
				else { // p2 == 's'
					return 2;
				}
			}
			else { // this means p1 is 's'
				if(p2 == 'r') {
					return 2;
				}
				else if(p2 == 'p') {
					return 1;
				}
				else { // p2 == 's'
					return 0;
				}
			}
		}
	}
	
	public static int max2(int a, int b, int c) {
		int result = -1;
		
		if(a <= b && b <= c) {
			result = b;
		}
		else if(a <= c && c <= b) {
			result = c;
		}
		else if(b <= a && a <= c) {
			result = a;
		}
		else if(b <= c && c <= a) {
			result = c;
		}
		else if(c <= a && a <= b) {
			result = a;
		}
		else if(c <= b && b <= a) { // c <= b <= a
			result = b;
		}
		
		return result;
	}
	
	public static int max2_(int[] array) {
		Arrays.sort(array);
		return array[1];
	}
	
	public static int max2Simple(int[] array) {
		
		// assumption: array.length == 3
		int a = array[0];
		int b = array[1];
		int c = array[2];
		int result = -1;
		
		if(a <= b && b <= c) {
			result = b;
		}
		else if(a <= c && c <= b) {
			result = c;
		}
		else if(b <= a && a <= c) {
			result = a;
		}
		else if(b <= c && c <= a) {
			result = c;
		}
		else if(c <= a && a <= b) {
			result = a;
		}
		else if(c <= b && b <= a) { // c <= b <= a
			result = b;
		}
		
		return result;
	}
	
	public static int max2(int[] a) {
		if(a == null || a.length < 2) {
			throw new IllegalArgumentException();
		}
		else {
			int max = -1;
			int max2 = -1;
			if(a[0] <= a[1]) {
				max = a[1];
				max2 = a[0];
			}
			else {
				max = a[0];
				max2 = a[1];
			}
			
			for(int i = 2; i < a.length; i ++) {
				int current = a[i];
				if(current < max2) {
					// nothing to change
				}
				else if(max2 < current && current <= max) {
					max2 = current;
				}
				else if(current >= max) {
					max = current;
					max2 = max;
				}
			}
			
			
			return max2;
		}
	}
}









