import static org.junit.Assert.*;

import java.util.ArrayList;

import org.junit.Test;

public class TestMyUtilities {

	@Test
	public void testReverse() {
		int[] ea = new int[0];
		int[] expected = new int[0];
		int[] actual = MyUtilities.reverseOf(ea);
		assertArrayEquals(expected, actual);
		
		int[] a1 = {1, 2, 3};
		int[] expected2 = {3, 2, 1};
		actual = MyUtilities.reverseOf(a1);
		assertArrayEquals(expected2, actual);
	}
	
	@Test
	public void testIsFibSeq() {
		int[] seq1 = {1, 1};
		assertTrue(MyUtilities.isFibSeq(seq1));
		
		int[] seq2 = {2, 2};
		assertFalse(MyUtilities.isFibSeq(seq2));
		
		int[] seq3 = {1, 1, 2, 3, 5, 8, 13};
		assertTrue(MyUtilities.isFibSeq(seq3));
		
		int[] seq4 = {2, 2, 4, 6, 10, 16, 26};
		assertFalse(MyUtilities.isFibSeq(seq4));
	}
	
	@Test
	public void testArrayList() {
		ArrayList<String> list = new ArrayList<>();
		list.add("alan");
		list.add("mark");
		list.add("tom");
		assertTrue(list.get(0).equals("alan"));
		assertTrue(list.get(1).equals("mark"));
		assertTrue(list.get(2).equals("tom"));
	}

}
